/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-webcomponents-core";
/**
 * Enumeration used to identify the context menus for the [[Spreadsheet]]
 */
export var SpreadsheetContextMenuArea = /*@__PURE__*/ (function (SpreadsheetContextMenuArea) {
    /**
     * The context menu for column headers in the [[Spreadsheet]] and for the cells when there is only a single range of columns selected.
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["Column"] = 0] = "Column";
    /**
     * The context menu for row headers in the [[Spreadsheet]] and for the cells when there is only a single range of rows selected.
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["Row"] = 1] = "Row";
    /**
     * The context menu for a cell selection in the [[Spreadsheet]].
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["Cell"] = 2] = "Cell";
    /**
     * The context menu for a Worksheet tab item in the [[Spreadsheet]].
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["Tab"] = 3] = "Tab";
    /**
     * The context menu for the control used to edit the cells within the [[Spreadsheet]].
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["InPlaceEditor"] = 4] = "InPlaceEditor";
    /**
     * The context menu for the control within the FormulaBarControl that is used to edit the value of the active cell in the [[Spreadsheet]].
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["FormulaBarEditor"] = 5] = "FormulaBarEditor";
    /**
     * The context menu for the select all button at the intersection of the row and column header areas
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["SelectAllButton"] = 6] = "SelectAllButton";
    /**
     * The context menu for a cell selection in the [[Spreadsheet]] when the active cell is part of a [[WorksheetTable]].
     */
    SpreadsheetContextMenuArea[SpreadsheetContextMenuArea["TableCell"] = 7] = "TableCell";
    return SpreadsheetContextMenuArea;
})({});
/**
 * @hidden
 */
export let SpreadsheetContextMenuArea_$type = /*@__PURE__*/ markEnum('SpreadsheetContextMenuArea', 'Column,0|Row,1|Cell,2|Tab,3|InPlaceEditor,4|FormulaBarEditor,5|SelectAllButton,6|TableCell,7');
//# sourceMappingURL=SpreadsheetContextMenuArea.js.map
